## gr1c-0.13.2.tar.gz

=== Makefile ===
# Build executables and documentation; run tests.
#
# SCL; 2012-2015.

RELEASE=1

CORE_PROGRAMS = gr1c gr1c-rg
EXP_PROGRAMS = gr1c-patch
AUX_PROGRAMS = gr1c-autman


prefix = /usr/local
exec_prefix = $(prefix)
bindir = $(exec_prefix)/bin
deps_prefix = extern

# Possibly change to `cp' when `install' is unavailable
INSTALL = install

INCLUDEDIR = include
SRCDIR = src
EXPDIR = exp

LEX = flex -X
LFLAGS = 
YACC = bison -y
YFLAGS = -d

CC = gcc
LD = ld -r

CFLAGS = -Wall -pedantic -std=c99 -I$(deps_prefix)/include -I$(INCLUDEDIR)
LDFLAGS = -L$(deps_prefix)/lib -lm -lcudd

# To use and statically link with GNU Readline
#CFLAGS += -DUSE_READLINE
#LDFLAGS += -lreadline

# N.B., scripted interaction tests, which are invoked if you run "make check",
# will fail if you build gr1c with GNU Readline.


# To measure test coverage
#CFLAGS += -fprofile-arcs -ftest-coverage
#LDFLAGS += -lgcov
ifeq ($(RELEASE),0)
	GR1C_GITHASH := $(shell git describe --dirty)
	ifdef GR1C_GITHASH
		GR1C_GITHASH := "+$(GR1C_GITHASH)"
	else
		GR1C_GITHASH := ""
	endif
	CFLAGS += -g -DGR1C_DEVEL=\".dev0$(GR1C_GITHASH)\"
else
	CFLAGS += -O3
endif


core: $(CORE_PROGRAMS) $(EXP_PROGRAMS) $(AUX_PROGRAMS)
all: core

gr1c: main.o util.o logging.o interactive.o solve_support.o solve_operators.o solve.o ptree.o automaton.o automaton_io.o gr1c_parse.o
	$(CC) -o $@ $^ $(LDFLAGS)

gr1c-rg: rg_main.o util.o patching_support.o logging.o solve_support.o solve_operators.o solve.o ptree.o automaton.o automaton_io.o rg_parse.o
	$(CC) -o $@ $^ $(LDFLAGS)

gr1c-autman: util.o logging.o solve_support.o ptree.o autman.o automaton.o automaton_io.o gr1c_parse.o
	$(CC) -o $@ $^ $(LDFLAGS)

gr1c-patch: grpatch.o util.o logging.o interactive.o solve_metric.o solve_support.o solve_operators.o solve.o patching.o patching_support.o patching_hotswap.o ptree.o automaton.o automaton_io.o gr1c_parse.o
	$(CC) -o $@ $^ $(LDFLAGS)

grjit: grjit.o sim.o util.o logging.o interactive.o solve_metric.o solve_support.o solve_operators.o solve.o ptree.o automaton.o automaton_io.o gr1c_parse.o
	$(CC) -o $@ $^ $(LDFLAGS)

autman.o: aux/autman.c
	$(CC) $(CFLAGS) -c $^

grpatch.o: $(EXPDIR)/grpatch.c
	$(CC) $(CFLAGS) -c $^
grjit.o: $(EXPDIR)/grjit.c
	$(CC) $(CFLAGS) -c $^

main.o: $(SRCDIR)/main.c $(INCLUDEDIR)/common.h
	$(CC) $(CFLAGS) -c $<
rg_main.o: $(SRCDIR)/rg_main.c $(INCLUDEDIR)/common.h
	$(CC) $(CFLAGS) -c $<
sim.o: $(SRCDIR)/sim.c
	$(CC) $(CFLAGS) -c $^
util.o: $(SRCDIR)/util.c
	$(CC) $(CFLAGS) -c $^
ptree.o: $(SRCDIR)/ptree.c
	$(CC) $(CFLAGS) -c $^
logging.o: $(SRCDIR)/logging.c
	$(CC) $(CFLAGS) -c $^
automaton.o: $(SRCDIR)/automaton.c
	$(CC) $(CFLAGS) -c $^
automaton_io.o: $(SRCDIR)/automaton_io.c $(INCLUDEDIR)/common.h
	$(CC) $(CFLAGS) -c $<
interactive.o: $(SRCDIR)/interactive.c $(INCLUDEDIR)/common.h
	$(CC) $(CFLAGS) -c $<
solve_metric.o: $(SRCDIR)/solve_metric.c
	$(CC) $(CFLAGS) -c $^
solve_support.o: $(SRCDIR)/solve_support.c
	$(CC) $(CFLAGS) -c $^
solve_operators.o: $(SRCDIR)/solve_operators.c
	$(CC) $(CFLAGS) -c $^
solve.o: $(SRCDIR)/solve.c
	$(CC) $(CFLAGS) -c $^
patching.o: $(SRCDIR)/patching.c
	$(CC) $(CFLAGS) -c $^
patching_support.o: $(SRCDIR)/patching_support.c
	$(CC) $(CFLAGS) -c $^
patching_hotswap.o: $(SRCDIR)/patching_hotswap.c
	$(CC) $(CFLAGS) -c $^

gr1c_parse.o: $(SRCDIR)/gr1c_scan.l $(SRCDIR)/gr1c_parse.y
	$(YACC) $(YFLAGS) $(SRCDIR)/gr1c_parse.y
	$(LEX) $<
	$(CC) $(CFLAGS) -c lex.yy.c y.tab.c
	$(LD) lex.yy.o y.tab.o -o $@
rg_parse.o: $(SRCDIR)/gr1c_scan.l $(SRCDIR)/rg_parse.y gr1c_parse.o
	$(YACC) $(YFLAGS) $(SRCDIR)/rg_parse.y
	$(LEX) $<
	$(CC) $(CFLAGS) -c lex.yy.c y.tab.c
	$(LD) lex.yy.o y.tab.o -o $@

install:
	$(INSTALL) $(CORE_PROGRAMS) $(EXP_PROGRAMS) $(AUX_PROGRAMS) $(DESTDIR)$(bindir)

uninstall:
	rm -f $(DESTDIR)$(bindir)/gr1c $(DESTDIR)$(bindir)/gr1c-rg $(DESTDIR)$(bindir)/gr1c-patch

check: $(CORE_PROGRAMS) $(EXP_PROGRAMS)
	$(MAKE) -C tests CC="$(CC)"

.PHONY: doc
doc:
	@(cd doc; doxygen; cd ..)

# Delete built documentation
.PHONY: dclean
dclean:
	-rm -fr doc/build/*

# Delete only executables and corresponding object code
.PHONY: eclean
eclean:
	-rm -f *~ *.o y.tab.h y.tab.c lex.yy.c $(CORE_PROGRAMS) $(EXP_PROGRAMS) $(AUX_PROGRAMS)
	-rm -f *.gcno *.gcda *.gcov

# Delete testing-related things
.PHONY: tclean
tclean:
	$(MAKE) -C tests clean

# Clean everything
clean: dclean eclean tclean

=== tests/Makefile ===
# Unit and integration tests of gr1c
#
# SCL; 2012, 2013.

deps_prefix = ../extern
INCLUDEDIR = include

CFLAGS = -g -Wall -pedantic -std=c99 -I$(deps_prefix)/include -I../$(INCLUDEDIR)
LDFLAGS = -L$(deps_prefix)/lib -lm -lcudd

# To measure test coverage
#CFLAGS += -fprofile-arcs -ftest-coverage
#LDFLAGS += -lgcov

PROGRAMS = test_util test_logging test_automaton test_aut_prune_deadends test_aut_aut_load test_aut_aut_dump test_ptree test_ptree_to_BDD test_bitblasting test_solve_support test_patching

all: $(PROGRAMS)
	./test_logging
	./test_ptree
	./test_ptree_to_BDD
	./test_bitblasting
	./test_automaton
	./test_aut_prune_deadends
	./test_aut_aut_load
	./test_aut_aut_dump
	./test_solve_support
	./test_patching
	./test_util
	sh test-gr1c.sh
	sh test-grpatch.sh
	sh test-cli.sh
	sh test-verification.sh
	@echo "============================================================\nPASSED\n"


COMMON_BINS = ../util.o ../automaton.o ../automaton_io.o ../ptree.o ../solve_support.o ../logging.o

test_util: test_util.c
	$(CC) $(CFLAGS) $^ $(COMMON_BINS) -o $@ $(LDFLAGS)

test_logging: test_logging.c
	$(CC) $(CFLAGS) $^ ../logging.o -o $@ $(LDFLAGS)

test_ptree: test_ptree.c
	$(CC) $(CFLAGS) $^ ../ptree.o -o $@ $(LDFLAGS)

test_ptree_to_BDD: test_ptree_to_BDD.c
	$(CC) $(CFLAGS) $^ ../ptree.o -o $@ $(LDFLAGS)

test_bitblasting: test_bitblasting.c
	$(CC) $(CFLAGS) $^ $(COMMON_BINS) -o $@ $(LDFLAGS)

test_automaton: test_automaton.c
	$(CC) $(CFLAGS) $^ $(COMMON_BINS) -o $@ $(LDFLAGS)

test_aut_prune_deadends: test_aut_prune_deadends.c
	$(CC) $(CFLAGS) $^ $(COMMON_BINS) -o $@ $(LDFLAGS)

test_aut_aut_load: test_aut_aut_load.c
	$(CC) $(CFLAGS) $^ $(COMMON_BINS) -o $@ $(LDFLAGS)

test_aut_aut_dump: test_aut_aut_dump.c
	$(CC) $(CFLAGS) $^ $(COMMON_BINS) -o $@ $(LDFLAGS)

test_solve_support: test_solve_support.c
	$(CC) $(CFLAGS) $^ $(COMMON_BINS) -o $@ $(LDFLAGS)

test_patching: test_patching.c
	$(CC) $(CFLAGS) $^ $(COMMON_BINS) ../patching.o ../patching_support.o -o $@ $(LDFLAGS)

clean:
	-rm -f *~ *.o $(PROGRAMS) temp_*_dump* dump*
	-rm -fr *.dSYM
	-rm -f *.gcno *.gcda *.gcov
	-rm -f pan* *.aut *.aut.pml *.aut.pml.trail
	-rm -f tmp.*

=== packaging/macports/Portfile ===
# -*- coding: utf-8; mode: tcl; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- vim:fenc=utf-8:ft=tcl:et:sw=4:ts=4:sts=4
# $Id$

PortSystem          1.0

name                gr1c
version             0.6.5
categories          math devel

license             BSD
maintainers         cds.caltech.edu:slivingston
description         Tools for GR(1) synthesis and related activities

long_description    A collection of tools for GR(1) synthesis and related \
                    activities.  Its core functionality is checking \
                    realizability of and synthesizing strategies for GR(1) \
                    specifications, though it does much more.

homepage            http://scottman.net/2012/gr1c
master_sites        http://vehicles.caltech.edu/snapshots/gr1c/
platforms           darwin
supported_archs     i386 x86_64

checksums           rmd160  9d3f4eb46a82f5f61b0459706639928a6a36b951 \
                    sha256  3c0daf15c7f0c243be7b99cea0618d3e11ff94c374ecbd5a1b31c8ac97455005

if {![string match "-arch x86_64" ${configure.cc_archflags}]
    && ![string match "-arch ppc64" ${configure.cc_archflags}]} {
    post-patch {
        reinplace "s|-DSIZEOF_VOID_P=8 -DSIZEOF_LONG=8|-malign-double|g" ${worksrcpath}/Makefile
    }
}

depends_build       port:bison port:flex
depends_lib         port:libcudd
universal_variant   no

use_configure       no

build.args          CUDD_INC="-I${prefix}/include/cudd" \
                    CUDD_LIB="-L${prefix}/lib/cudd -lcudd"

test.run            yes
test.target         check
test.args           CUDD_INC="-I${prefix}/include/cudd" \
                    CUDD_LIB="-L${prefix}/lib/cudd -lcudd"
destroot {
    xinstall -m 0755 -W ${worksrcpath} gr1c rg grpatch ${destroot}${prefix}/bin
}
